#include <LiquidCrystal.h>
//Final version of the current pulse source prototype sequence control.
//Build date: 08.05.2014

//Defining LCD-panel pins:
LiquidCrystal lcd(12, 11, 8, 7, 6, 5); 

//Variables: 
double voltlvl = 0;   //Variable which calcualtes and stores the actual voltage level.
int rdyfire = 0;       //Variable indicating that the system is ready to charge. 
int sequence = 0;
int buttonstate = 0;
int n = 0;
int k = 0;
int pwm = 64;

//Outputs:
int voltpin = 0;       //Voltage input (A0)
int rotpot = 1;        //Setpoint input (A1)
int DAQtrigg = 3;      //DAQ trigger signal.
int fire = 4;          //Thyristor trigger signal.
int pinshutdown = 9;   //Signal for DC/DC-converter remote shutdown. 
int pinexbias = 10;    //Signal for DDC/DC-converter ext. bias.
int button = 13;       //Trigger Button pin

void setup() {  
  Serial.begin(9600);
  lcd.begin(16, 2);

  //Defining if the the digital IO is and input or output.
  pinMode(pinshutdown, OUTPUT);
  pinMode(pinexbias, OUTPUT);
  pinMode(fire, OUTPUT);
  pinMode(DAQtrigg, OUTPUT);
  pinMode(button, INPUT);
}

void loop() {
  digitalWrite(pinshutdown,HIGH);
  digitalWrite(pinexbias,LOW);
  
    //Boot sequence in lcd display
  while (millis() < 5000){ 
    lcd.setCursor(0,0);
    lcd.print("Pulse Src. v.1.0");
    lcd.setCursor(0,1);
    lcd.print("Initializing");
    delay(500);
    lcd.setCursor(0,1);
    lcd.print("Initializing.");
    delay(500);
    lcd.setCursor(0,1);
    lcd.print("Initializing..");
    delay(500);
    lcd.setCursor(0,1);
    lcd.print("Initializing...");
    delay(500);
    lcd.clear();
  }
  
  if (n == false){
    lcd.clear();
    n = 1;
  }
  
  //Outer Sequence:
  double setpoint = analogRead(rotpot);
  double voltlvl = analogRead(voltpin);
  delay(50);
  
  lcd.setCursor(0,0);
  lcd.print("Vchg: ");
  lcd.print(voltlvl/1023*303.8,1);
  lcd.setCursor(0,1);
  lcd.print("Vset: ");
  lcd.print(setpoint/1023*300,1);
  
  buttonstate = digitalRead(button);
  
  if(buttonstate == HIGH){
    lcd.clear();
    sequence = 1;
    delay(100);
  }
  
  while (sequence == HIGH){
    digitalWrite(pinexbias,HIGH);
    voltlvl = analogRead(voltpin);

    if (voltlvl <= setpoint){
      voltlvl = analogRead(voltpin);
    
      if (k == false){  
        if(setpoint <= 85.0){
          analogWrite(pinshutdown,pwm); 
          delay(5);
          lcd.setCursor(0,0);
          lcd.print("PWM Charging!");
          k = 1;
        }   
      
        if (setpoint > 85.0){     
          digitalWrite(pinshutdown,LOW);  
          delay(5);
          lcd.setCursor(0,0);
          lcd.print("Charging!");
          k = 1; 
        }
      }
      lcd.setCursor(0,1);
      lcd.print("Vchg: ");
      lcd.print(voltlvl*303.80/1023,1); 
      delay(5);      
    }
    
    if (voltlvl >= setpoint + 2){
      digitalWrite(pinshutdown,HIGH);
      rdyfire = 1;
      delay(1);
      lcd.clear();
    }
    
    while (rdyfire == HIGH){
      voltlvl = analogRead(voltpin);
      lcd.setCursor(0,0);
      lcd.print("Fireing!");
      
      if (voltlvl <= setpoint){
        digitalWrite(DAQtrigg,HIGH);
        //delay(1);
        digitalWrite(DAQtrigg,LOW);
        delay(1);
        digitalWrite(fire,HIGH);
        delay(5);        
        digitalWrite(fire,LOW);
        rdyfire = 0;
        sequence = 0;
        k=0;
        lcd.clear();
        delay(50); 
      }
      delay(1);
    }
  delay(1);
  }  
}  
